--[[
************************************************************************
AltsMains
$Date: 2008-10-20 02:23:58 +0000 (Mon, 20 Oct 2008) $
$Revision: 894 $
Author: Zhinjio of Hellscream
************************************************************************
File		: AltsMains.lua

Description	:
	This stores in its SV all values present in the libalts "live" data.
	It pushes its data back into libalts on load, and listens for updates
	from libalts as well.

TODO		:
	Eventually, I'll put in some extra crap, like scanning the guild
	notes for alt-main definitions. For now, this does what it was
	designed to do

************************************************************************
(see bottom of file for changelog)
************************************************************************
--]]
local AltsMains = LibStub( "AceAddon-3.0"):NewAddon( "AltsMains", "AceConsole-3.0" )
-- I'll need to remove this eventually, but for now, I'm not using it
-- local L = LibStub( "AceLocale-3.0"):GetLocale( "AltsMains" )
local Libalts = LibStub( "LibAlts-1.0" )
local initString = "AltsMains loaded. (by Zhinjio - version 1.0, 10/22/2008)"
local db

-- on init
function AltsMains:OnInitialize()
    -- Called when the addon is loaded
    self.db = LibStub("AceDB-3.0"):New("AltsMainsDB")
	db = self.db.realm
	db.Mains = db.Mains or {}

	-- Loop on SV values, and send them to libalts
	for k,v in pairs( db.Mains ) do
		for i, a in pairs( v ) do
			Libalts:SetAlt( k, a )
		end
	end

	-- Once we're done with that, we can register for the libalt events...
	Libalts.RegisterCallback( self, "LibAlts_SetAlt", "MyEventHandler" )
end

function AltsMains:OnEnable()
    -- Called when the addon is enabled
end

function AltsMains:OnDisable()
    -- Called when the addon is disabled
end

-- This event is fired whenever libalts sets something. When that happens,
-- presumably, I have some data in my db to update (and on exit, save)
function AltsMains:MyEventHandler( event, main, alt )
	-- check to see if this association already exists. If it doesn't, add it in.
	db = self.db.realm
	if ( db.Mains[main] ) then
		local found = false
		for i, a in pairs ( db.Mains[main] ) do
			if ( a == alt ) then
				found = true
				break
			end
		end
		if ( found == false ) then
			tinsert( db.Mains[main], alt )
		end
	else
		db.Mains[main] = {}
		tinsert( db.Mains[main], alt )
	end
end

-- Register our chat command, and set its function
AltsMains:RegisterChatCommand( "altsmains", "OnSlashCommand")

function AltsMains:OnSlashCommand( text )
	self:Print( initString )
end

--[[
************************************************************************
CHANGELOG:

Date : 10/21/08
	Initial file. 
************************************************************************
]]--